//+------------------------------------------------------------------+
//|                                                 Wilder's DMI.mq4 |
//|                                                  coded by mladen |
//|                                                                  |
//| Directional movement index was developed by Welles Wilder        |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_separate_window
#property  indicator_buffers 5
#property indicator_minimum  0
#property indicator_color1   Lime
#property indicator_color2   Tomato
#property indicator_color3   DimGray
#property indicator_color4   Orange
#property indicator_color5   DimGray
#property indicator_width3   2 
#property indicator_width4   2 
#property indicator_style1   STYLE_DOT
#property indicator_style2   STYLE_DOT
#property indicator_style5   STYLE_DOT

//
//
//
//
//

extern int    DMI_Length                      = 14;
extern bool   ShowADX                         = true;
extern bool   ShowADXR                        = false;
extern double Level                           = 20.0;
extern double PlusMinusLevel                  = 20.0;
extern string note                            = "turn on Alert = true; turn off = false";
extern bool   alertsOn                        = true;
extern bool   alertsOnCurrent                 = true;
extern bool   alertsOnLevelCross              = true;
extern bool   alertsOnDiPlusDiMinusCross      = true;
extern bool   alertsOnDiPlusDiMinusLevelCross = true;
extern bool   alertsMessage                   = true;
extern bool   alertsSound                     = true;
extern bool   alertsNotify                    = false;
extern bool   alertsEmail                     = false;
extern string soundFile                       = "alert2.wav";


//
//
//
//
//

double DIp[];
double DIm[];
double ADX[];
double ADXR[];
double ADXLevel[];
double averageDIp[];
double averageDIm[];
double averageTR[];
double trend[];
double trend1[];
double trend2[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//

int init()
{
   IndicatorBuffers(11);
   SetIndexBuffer(0,DIp);      SetIndexLabel(0,"DI+");
   SetIndexBuffer(1,DIm);      SetIndexLabel(1,"DI-");
   SetIndexBuffer(2,ADX);      SetIndexLabel(2,"ADX");
   SetIndexBuffer(3,ADXR);     SetIndexLabel(3,"ADXR");
   SetIndexBuffer(4,ADXLevel); SetIndexLabel(4,NULL);
   SetIndexBuffer(5,averageDIp);
   SetIndexBuffer(6,averageDIm);
   SetIndexBuffer(7,averageTR);
   SetIndexBuffer(8,trend);
   SetIndexBuffer(9,trend1);
   SetIndexBuffer(10,trend2);
      for (int i=0;i<8;i++) SetIndexEmptyValue(i,0.00);

   //
   //
   //
   //
   //

   IndicatorShortName("Wilder\'s DMI ("+DMI_Length+")");
   return(0);
}

int deinit()
{
   return(0);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=Bars-counted_bars;
           limit=MathMin(limit,Bars-2);

   //
   //
   //
   //
   //
   
   double sf = (DMI_Length-1.0)/DMI_Length;
      for (i=limit;i>=0;i--)
      {
         double currTR  = MathMax(High[i],Close[i+1])-MathMin(Low[i],Close[i+1]);
         double DeltaHi = High[i]  - High[i+1];
	      double DeltaLo = Low[i+1] - Low[i];
         double plusDM  = 0.00;
         double minusDM = 0.00;
         
            if ((DeltaHi > DeltaLo) && (DeltaHi > 0)) plusDM  = DeltaHi;
            if ((DeltaLo > DeltaHi) && (DeltaLo > 0)) minusDM = DeltaLo;      
         
         //
         //
         //
         //
         //
         
            averageDIp[i] = sf*averageDIp[i+1] + plusDM;
            averageDIm[i] = sf*averageDIm[i+1] + minusDM;
            averageTR[i]  = sf*averageTR[i+1]  + currTR;
            ADXLevel[i]   = Level;

         //
         //
         //
         //
         //
                  
            DIp[i] = 0.00;                   
            DIm[i] = 0.00;                   
            if (averageTR[i] > 0)
               {              
                  DIp[i] = 100.00 * averageDIp[i]/averageTR[i];
                  DIm[i] = 100.00 * averageDIm[i]/averageTR[i];
               }            

            if(ShowADX)
               {
                  double DX;
                  if((DIp[i] + DIm[i])>0) 
                       DX = 100*MathAbs(DIp[i] - DIm[i])/(DIp[i] + DIm[i]); 
                  else DX = 0.00;
                  ADX[i] = sf*ADX[i+1] + DX/DMI_Length; 
                  if(ShowADXR)
                         ADXR[i] = 0.5*(ADX[i] + ADX[i+DMI_Length]);
               }
               
               //
               //
               //
               //
               //
               
               trend[i]  = 0;
               trend1[i] = trend1[i+1];
               trend2[i] = trend2[i+1];
               if (ADX[i] > Level)                             trend[i]  = 1;
               if (ADX[i] < Level)                             trend[i]  =-1;
               if (DIp[i] > DIm[i])                            trend1[i] = 1;
               if (DIp[i] < DIm[i])                            trend1[i] =-1;
               if (DIp[i] > DIm[i] && DIp[i] > PlusMinusLevel) trend2[i] = 1;
               if (DIp[i] < DIm[i] && DIm[i] > PlusMinusLevel) trend2[i] =-1;
      }   
      
      //
      //
      //
      //
      //
            
      if (alertsOn)
      {
        if (alertsOnCurrent)
             int whichBar = 0;
        else     whichBar = 1;
    
        //
        //
        //
        //
        //
      
        static datetime time1 = 0;
        static string   mess1 = "";
           if (alertsOnLevelCross && trend[whichBar] != trend[whichBar+1])
           {
              if (trend[whichBar] == 1) doAlert(time1,mess1,whichBar," crossing level up");
              if (trend[whichBar] ==-1) doAlert(time1,mess1,whichBar," crossing level down");
           }            
        static datetime time2 = 0;
        static string   mess2 = "";
           if (alertsOnDiPlusDiMinusCross && trend1[whichBar] != trend1[whichBar+1])
           {
              if (trend1[whichBar] == 1) doAlert(time2,mess2,whichBar," DiPlus crossing DiMinus up trend");
              if (trend1[whichBar] ==-1) doAlert(time2,mess2,whichBar," DiPlus crossing DiMinus down trend");
           }
        static datetime time3 = 0;
        static string   mess3 = "";
           if (alertsOnDiPlusDiMinusLevelCross && trend2[whichBar] != trend2[whichBar+1])
           {
              if (trend2[whichBar] == 1) doAlert(time2,mess2,whichBar," DiPlus crossing DiMinus and DiPlus crossing level ");
              if (trend2[whichBar] ==-1) doAlert(time2,mess2,whichBar," DiPlus crossing DiMinus and DiMinus crossing level");
           }                                                
}
return(0);
}   

//
//
//
//
//

void doAlert(datetime& previousTime, string& previousAlert, int forBar, string doWhat)
{
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Wilders DMI book ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Wilders DMI book "),message);
             if (alertsNotify)  SendNotification(message);
             if (alertsSound)   PlaySound(soundFile);
      }
}
       

